;=======================================================================================
; Code :
; Project Title :
; Author : Philippe Agnisola
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_TimeMachine.bb"
Include "Inc_EasyTOK.bb"

; ------------------------
; Freelook cam var
; ------------------------
Global Mouse_X_Speed#
Global Mouse_Y_Speed#
Global Camera_VelX#
Global Camera_VelZ#
Global Camera_Pitch
Global Camera_Yaw

; ------------------------------
; Nombre d'image MAX
; ------------------------------
Global AppFPS =60

; ---------------------------
; Ouverture de l'ecran
; ---------------------------
Graphics3D 1024, 768,32,2
SetBuffer BackBuffer ()

; ---------------------------------
; Changement de la fonte
; ---------------------------------
AppFont=LoadFont("Arial",15,1,0,0) 
SetFont AppFont

; ----------------------------------------
; Setup camera and Easytok
; ----------------------------------------
Global Cam=CreateCamera()
PositionEntity Cam,0,13200,-40
CameraRange Cam,1,600000
CameraClsColor Cam,50,100,150

Proc_CreateVisor()

; -----------------------------
; Creating demo world
; -----------------------------
Global Light1=CreateLight(2)
PositionEntity Light1,-50,50,-50
LightColor Light1,250,150,50
LightRange Light1,100

Global Light2=CreateLight(2)
PositionEntity Light2,50,50,50
LightColor Light2,50,150,250
LightRange Light2,100

AmbientLight 100,150,200
TOK_InitWorld(0,-40,0,1000,100)

Global Tmp$="Ball"
TOK_CreateRBCube(Tmp$,False,EntityX(Cam),EntityY(Cam)-3,EntityZ(Cam),EntityPitch(Cam),EntityYaw(cam),EntityRoll(cam),15,5,22,2,"",Rnd(255),Rnd(255),Rnd(255),1,0)
TOK_ApplyMaterial(Tmp$,TOK_TypeRigidBody%,"Metal")
EntityParent Cam,TOK_GetRBMesh(Tmp$)

Proc_CreatePhysicFromBlitzTerrain("./ETOK_Medias/Terrain_Height.jpg","./ETOK_Medias/Terrain_Color.jpg","./ETOK_Medias/Terrain_Detail.jpg","./ETOK_Medias/Terrain_Shadow.jpg",1500,66650)

Global Twist_Value#
Global Speed_Value#

; -----------------------------------------------
;	Boucle principale du programme
; -----------------------------------------------
FramePeriod = 1000 / AppFPS
FrameTime = MilliSecs () - FramePeriod
MoveMouse GraphicsWidth()/2, GraphicsHeight()/2

Repeat
	; --------------------------
	; Frame rate limiting
	; --------------------------
	Repeat
		FrameElapsed = MilliSecs () - FrameTime
	Until FrameElapsed

	FrameTicks = FrameElapsed / FramePeriod
	FrameTween# = Float (FrameElapsed Mod FramePeriod) / Float (FramePeriod)

	; -----------------------
	; Update tweening
	; -----------------------
	For FrameLimit = 1 To FrameTicks
		If FrameLimit = FrameTicks Then
			CaptureWorld
		EndIf

		FrameTime = FrameTime + FramePeriod
		
		UpdateGame ()
		UpdateWorld
	Next

	
	; -------------------
	; Redraw world
	; -------------------
	TOK_RefreshEasyTOK()
	RenderWorld FrameTween
	
	; ---------------------
	; FPS Displaying
	; ---------------------
	Proc_CinemaStrip()
	Color 255,255,255
	Information$="<"+Get_FPS()+" FPS> / "+"<Arrow key to move> "+ Speed_Value#
	Text GraphicsWidth()/2,GraphicsHeight()-30,Information$,True,True
	Flip
Until KeyHit (1)

; -------------
; End App
; -------------
TOK_FreePhysic()
FreeFont  AppFont
End

; -------------------------------------
; Tweening update function
; -------------------------------------
Function UpdateGame ()
	;Proc_Freelook(Cam,1.05,0.05)

	If  KeyDown(57) Then
		TOK_ApplyImpulse(Tmp$,0,5,0)
	EndIf




;
; Mouse_X_Speed#=MouseXSpeed()*100.5
; Mouse_Y_Speed#=MouseYSpeed()*100.5
; MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
; TOK_ApplyTwist(Tmp$,0, Mouse_X_Speed#,0)

 	If KeyDown(203) Then
		
		 Twist_Value#=Twist_Value#-10
	EndIf

	If KeyDown(205) Then
		 Twist_Value#=Twist_Value#+10
	EndIf

	 TOK_ApplyTwist(Tmp$,0, Twist_Value#,0)

TOK_ApplyImpulseWithAngle(Tmp$,0,EntityYaw(Cam,True),0)
	

 	If KeyDown(200) Then
	Speed_Value#=Speed_Value#+0.2
	If Speed_Value#>=20 Then Speed_Value#=20
	ElseIf KeyDown(208) Then
	Speed_Value#=Speed_Value#-0.2
	If Speed_Value#<=-20 Then Speed_Value#=-20
	EndIf


	

	TOK_ApplyImpulseWithAngle(Tmp$,0,EntityYaw(Cam,True),Speed_Value#)
	
	; ---------------------	
	; Update physic
	; ---------------------
	If MouseDown(2)
		TOK_RefreshPhysic(0.2/AppFPS,10)
	Else
		TOK_RefreshPhysic(1.7/AppFPS,10)
	EndIf 
End Function

; ----------------------
; Camera freelook
; ----------------------
Function Proc_Freelook(CamEntity,Velocity#,Speed#)
 Mouse_X_Speed#=MouseXSpeed()*0.5
 Mouse_Y_Speed#=MouseYSpeed()*0.5

 MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
 Camera_Pitch=Camera_Pitch+Mouse_Y_Speed#
 Camera_Yaw=Camera_Yaw+Mouse_X_Speed#


 RotateEntity CamEntity,Camera_Pitch,-Camera_Yaw,0

 If KeyDown(203) Then
   Camera_VelX=Camera_VelX-Speed#
 ElseIf  KeyDown(205)
   Camera_VelX=Camera_VelX+Speed#
 EndIf
 If KeyDown(208) Then
   Camera_VelZ=Camera_VelZ-Speed#
 ElseIf  KeyDown(200)
   Camera_VelZ=Camera_VelZ+Speed#
 EndIf
 
 Camera_VelX=Camera_VelX/velocity#
 Camera_VelZ=Camera_VelZ/velocity#
 MoveEntity CamEntity,Camera_VelX,0,Camera_VelZ

 If KeyDown(200) Then
   MoveEntity CamEntity,0,0,Speed#
 EndIf

 If KeyDown(208) Then
   MoveEntity CamEntity,0,0,-Speed#
 EndIf

 If KeyDown(205) Then
   MoveEntity CamEntity,Speed#,0,0
 EndIf

 If KeyDown(203) Then
   MoveEntity CamEntity,-Speed#,0,0
 EndIf
End Function

; -----------------------
; Create the visor
; -----------------------
Function Proc_CreateVisor()
	Visor=LoadSprite("./ETOK_Medias/Target.png")
	PositionEntity Visor,EntityX(Cam),EntityY(Cam),EntityZ(Cam)+2
	ScaleSprite Visor,0.1,0.1
	EntityParent Visor,Cam
	EntityOrder Visor,-1
End Function

; ----------------------------------
; Create the cinema strip
; ----------------------------------
Function Proc_CinemaStrip(Size=60)
	Color 1,1,1
	Rect 0,0,GraphicsWidth(),Size
	Rect 0,GraphicsHeight()-Size,GraphicsWidth(),Size
End Function

; -------------------------------------------------
; Create physic from a blitz terrain ! 
; -------------------------------------------------
Function Proc_CreatePhysicFromBlitzTerrain(Heightmap$,Colormap$,DetailMap$,ShadowMap$,ScaleXZ,ScaleY)
	Terrain_Blitz=LoadTerrain(Heightmap$) 
	Terrain_Scale=ScaleXZ
	Terrain_Height=ScaleY

	Terrain_WidthXZ=TerrainSize(Terrain_Blitz)*Terrain_Scale
	
	Terrain_PosX=-(Terrain_WidthXZ)/2
	Terrain_PosY=0
	Terrain_PosZ=-(Terrain_WidthXZ)/2
	
	ScaleEntity Terrain_Blitz,Terrain_Scale,Terrain_Height,Terrain_Scale
	PositionEntity Terrain_Blitz,Terrain_PosX,Terrain_PosY,Terrain_PosZ

	Terrain_Color=LoadTexture(Colormap$)
	EntityTexture Terrain_Blitz,Terrain_Color,0,1
	ScaleTexture Terrain_Color,TerrainSize(Terrain_Blitz),TerrainSize(Terrain_Blitz)
	FreeTexture Terrain_Color

	If DetailMap$<>"" Then
		Terrain_Detail=LoadTexture(DetailMap$)
		EntityTexture Terrain_Blitz,Terrain_Detail,0,2
		ScaleTexture Terrain_Detail,10,10
		FreeTexture Terrain_Detail
	EndIf

	If ShadowMap$<>"" Then
		Terrain_Shadow=LoadTexture(ShadowMap$)
		EntityTexture Terrain_Blitz,Terrain_Shadow,0,3 : TextureBlend Terrain_Shadow,5
		ScaleTexture Terrain_Shadow,TerrainSize(Terrain_Blitz),TerrainSize(Terrain_Blitz)
		FreeTexture Terrain_Shadow
	EndIf
	
	TOK_CreateTerrainPhysique(Terrain_Blitz,Terrain_WidthXZ)
End Function