;=======================================================================================
; Code : EasyTok librarie example
; Project Title : EasyTok librarie example
; Author : Philippe Agnisola
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_TimeMachine.bb"
Include "Inc_EasyTOK.bb"

; ------------------------
; Freelook cam var
; ------------------------
Global Mouse_X_Speed#
Global Mouse_Y_Speed#
Global Camera_VelX#
Global Camera_VelZ#
Global Camera_Pitch
Global Camera_Yaw

; -------------------------------
; Refresh frame number
; -------------------------------
Global AppFPS =60

; ------------------
; Open screen
; ------------------
Graphics3D 1024, 768,32

SetBuffer BackBuffer ()

; ----------------------
; Change font text
; ----------------------
AppFont=LoadFont("Arial",15,1,0,0) 
SetFont AppFont

; -------------------------------------
; Setup camera and Easytok
; -------------------------------------
Global Cam=CreateCamera()
PositionEntity Cam,0,20,-40
EntityRadius Cam,3
EntityType Cam,1

Proc_CreateVisor()

TOK_InitWorld(0,-40,0,1000,100)
TOK_CreateGround("Floor",150,255,150,10)
TOK_EntityType("Floor",2)

; -----------------------------
; Creating demo world
; -----------------------------
Global Light1=CreateLight(2)
PositionEntity Light1,-50,50,-50
LightColor Light1,250,150,50
LightRange Light1,100

Global Light2=CreateLight(2)
PositionEntity Light2,50,50,50
LightColor Light2,50,150,250
LightRange Light2,100

AmbientLight 80,90,100

Global Entity_Collided
Const Cube_Scale=3.9

For I=-30 To  30 Step 8
	TOK_CreateRBCube("Toto1"+I,False,I,6,0,0,0,0,Cube_Scale,Cube_Scale,Cube_Scale,1,"",Rnd(255),Rnd(255),Rnd(255),1,0)
	TOK_EntityType("Toto1"+I,2)
Next

For I=-30 To  30 Step 8
	TOK_CreateRBCube("Toto2"+I,False,I,14,0,0,0,0,Cube_Scale,Cube_Scale,Cube_Scale,1,"",Rnd(255),Rnd(255),Rnd(255),1,0)
	TOK_EntityType("Toto2"+I,2)
Next

For I=-30 To  30 Step 8
	TOK_CreateRBCube("Toto3"+I,False,I,22,0,0,0,0,Cube_Scale,Cube_Scale,Cube_Scale,1,"",Rnd(255),Rnd(255),Rnd(255),1,0)
	TOK_EntityType("Toto3"+I,2)
Next

For I=-30 To  30 Step 8
	TOK_CreateRBCube("Toto4"+I,False,I,30,0,0,0,0,Cube_Scale,Cube_Scale,Cube_Scale,1,"",Rnd(255),Rnd(255),Rnd(255),1,0)
	TOK_EntityType("Toto4"+I,2)
Next

For I=-30 To  30 Step 8
	TOK_CreateRBCube("Toto5"+I,False,I,38,0,0,0,0,Cube_Scale,Cube_Scale,Cube_Scale,1,"",Rnd(255),Rnd(255),Rnd(255),1,0)
	TOK_EntityType("Toto5"+I,2)
Next

For I=-30 To  30 Step 8
	TOK_CreateRBCube("Toto6"+I,False,I,46,0,0,0,0,Cube_Scale,Cube_Scale,Cube_Scale,1,"",Rnd(255),Rnd(255),Rnd(255),1,0)
	TOK_EntityType("Toto6"+I,2)
Next

For I=-30 To  30 Step 8
	TOK_CreateRBCube("Toto7"+I,False,I,54,0,0,0,0,Cube_Scale,Cube_Scale,Cube_Scale,1,"",Rnd(255),Rnd(255),Rnd(255),1,0)
	TOK_EntityType("Toto7"+I,2)
Next

For I=-30 To  30 Step 8
	TOK_CreateRBCube("Toto8"+I,False,I,62,0,0,0,0,Cube_Scale,Cube_Scale,Cube_Scale,1,"",Rnd(255),Rnd(255),Rnd(255),1,0)
	TOK_EntityType("Toto8"+I,2)
Next

Collisions 1,2,2,3

; -------------
; Main loop
; -------------
FramePeriod = 1000 / AppFPS
FrameTime = MilliSecs () - FramePeriod
MoveMouse GraphicsWidth()/2, GraphicsHeight()/2

Repeat
	; --------------------------
	; Frame rate limiting
	; --------------------------
	Repeat
		FrameElapsed = MilliSecs () - FrameTime
	Until FrameElapsed

	FrameTicks = FrameElapsed / FramePeriod
	FrameTween# = Float (FrameElapsed Mod FramePeriod) / Float (FramePeriod)

	; -----------------------
	; Update tweening
	; -----------------------
	For FrameLimit = 1 To FrameTicks
		If FrameLimit = FrameTicks Then
			CaptureWorld
		EndIf

		FrameTime = FrameTime + FramePeriod
		
		UpdateGame ()
		UpdateWorld
	Next

	; -------------------
	; Redraw world
	; -------------------
	TOK_RefreshEasyTOK()
	RenderWorld FrameTween
	
	; -----------------------
	; FPS Displaying
	; -----------------------
	Proc_CinemaStrip() 
	Color 255,255,255
	Information$="<"+Get_FPS()+" FPS> / "+"<Arrow key to move> / <Mouse left to shoot> / <Use the camera to push objects>"
	Text GraphicsWidth()/2,GraphicsHeight()-30,Information$,True,True
	Flip
Until KeyHit (1)

; -----------
; End App
; -----------
TOK_FreePhysic()
FreeFont  AppFont
End

; -----------------------------------
; Tweening update function
; -----------------------------------
Function UpdateGame ()
	Proc_Freelook(Cam,1.05,0.05)

	If MouseHit(1) Then
		Tmp$="Bullet"+Rnd(1000)
		TOK_CreateRBSphere(Tmp$,False,EntityX(Cam),EntityY(Cam),EntityZ(Cam),EntityPitch(Cam),EntityYaw(cam),EntityRoll(cam),1,10,"",Rnd(255),Rnd(255),Rnd(255),1,10)
		TOK_ApplyImpulseWithAngle(Tmp$,EntityPitch(Cam),EntityYaw(cam),3000)
		TOK_ApplyMaterial(Tmp$,TOK_TypeRigidBody%,"Ice")
	EndIf

	; -----------------------------------------------------------
	; Define if the camera collide a toka object
	; -----------------------------------------------------------
	Local Power=20
	
	If CountCollisions(Cam)>0 Then
		For k=1 To CountCollisions(cam)
			Entity_Collided=CollisionEntity(Cam,k)

			If TOK_IsRigidBody(Entity_Collided)=True Then
				TOK_ApplyImpulse2(TOK_GetRBName$(Entity_Collided),-Power*CollisionNX(Cam,k),-Power*CollisionNY(Cam,k),-Power*CollisionNZ(Cam,k),CollisionX(Cam,k),CollisionY(Cam,k),CollisionZ(Cam,k))
			EndIf
		Next
	EndIf

	; -------------------------------------------------
	; Applying SlowMotion matrix like :)
	; --------------------------------------------------
	TOK_RefreshPhysic(0.3/AppFPS,7)
End Function

; -----------------------
; Create the visor
; -----------------------
Function Proc_CreateVisor()
	Visor=LoadSprite("./ETOK_Medias/Target.png")
	PositionEntity Visor,EntityX(Cam),EntityY(Cam),EntityZ(Cam)+2
	ScaleSprite Visor,0.1,0.1
	EntityParent Visor,Cam
	EntityOrder Visor,-1
End Function

; ----------------------------------
; Create the cinema strip
; ----------------------------------
Function Proc_CinemaStrip(Size=60)
	Color 1,1,1
	Rect 0,0,GraphicsWidth(),Size
	Rect 0,GraphicsHeight()-Size,GraphicsWidth(),Size
End Function

; ----------------------
; Camera freelook
; ----------------------
Function Proc_Freelook(CamEntity,Velocity#,Speed#)
	Mouse_X_Speed#=MouseXSpeed()*0.5
	Mouse_Y_Speed#=MouseYSpeed()*0.5

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	Camera_Pitch=Camera_Pitch+Mouse_Y_Speed#
	Camera_Yaw=Camera_Yaw+Mouse_X_Speed#

	RotateEntity CamEntity,Camera_Pitch,-Camera_Yaw,0

	If KeyDown(203) Then
		Camera_VelX=Camera_VelX-Speed#
	ElseIf  KeyDown(205)
		Camera_VelX=Camera_VelX+Speed#
	EndIf
	
	If KeyDown(208) Then
		Camera_VelZ=Camera_VelZ-Speed#
	ElseIf  KeyDown(200)
		Camera_VelZ=Camera_VelZ+Speed#
	EndIf
 
	Camera_VelX=Camera_VelX/velocity#
	Camera_VelZ=Camera_VelZ/velocity#
	MoveEntity CamEntity,Camera_VelX,0,Camera_VelZ

	If KeyDown(200) Then
		MoveEntity CamEntity,0,0,Speed#
	EndIf

	If KeyDown(208) Then
		MoveEntity CamEntity,0,0,-Speed#
	EndIf

	If KeyDown(205) Then
		MoveEntity CamEntity,Speed#,0,0
	EndIf

	If KeyDown(203) Then
		MoveEntity CamEntity,-Speed#,0,0
	EndIf
End Function