;=======================================================================================
; Code :
; Project Title :
; Author : Philippe Agnisola
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_TimeMachine.bb"
Include "Inc_EasyTOK.bb"

; ------------------------
; Freelook cam var
; ------------------------
Global Mouse_X_Speed#
Global Mouse_Y_Speed#
Global Camera_VelX#
Global Camera_VelZ#
Global Camera_Pitch
Global Camera_Yaw

; ------------------------------
; Nombre d'image MAX
; ------------------------------
Global AppFPS =60

; ---------------------------
; Ouverture de l'ecran
; ---------------------------
Graphics3D 1024, 768,32,0
SetBuffer BackBuffer ()

; ---------------------------------
; Changement de la fonte
; ---------------------------------
AppFont=LoadFont("Arial",15,1,0,0) 
SetFont AppFont

; ----------------------------------------
; Setup camera and Easytok
; ----------------------------------------
Global Cam=CreateCamera()
PositionEntity Cam,0,35,-40

Proc_CreateVisor()

TOK_InitWorld(0,-40,0,1000,100)
TOK_CreateGround("Floor",150,255,150,10)
TOK_ApplyMaterial("CarBody",TOK_TypeAnimBody%,"Metal")

; -----------------------------
; Creating demo world
; -----------------------------
Global Light1=CreateLight(2)
PositionEntity Light1,-50,50,-50
LightColor Light1,250,150,50
LightRange Light1,100

Global Light2=CreateLight(2)
PositionEntity Light2,50,50,50
LightColor Light2,50,150,250
LightRange Light2,100

AmbientLight 80,90,100

; -----------------------------
; Create random cube
; -----------------------------
TOK_CreateABCube("Wall01",0,3,15,-15,0,0,15,0.3,15,"",255,150,10,1)
TOK_CreateABCube("Wall02",0,3,45,-15,180,0,15,0.3,15,"",255,150,10,1)
TOK_CreateABCube("Wall03",40,3,45,-15,180,0,15,0.3,15,"",255,150,10,1)
TOK_CreateABCube("Wall04",40,6.9,15,0,180,0,15,0.3,15,"",255,150,10,1)
TOK_CreateABCube("Wall05",40,3,-14,15,180,0,15,0.3,15,"",255,150,10,1)
Cube_Scale=1

For I=1 To 30
	TOK_CreateRBCube("Toto1"+I,False,Rnd(-100,100),10,Rnd(-100,100),0,0,0,Cube_Scale,Cube_Scale*2,Cube_Scale,0.1,"",Rnd(255),Rnd(255),Rnd(255),1,0)
	TOK_ApplyMaterial("Toto1"+I,TOK_TypeRigidBody%,"Ice")
Next

; ------------------------
; Create Car Body
; ------------------------
Px#=70 : Py#=8.0 : Pz#=0
JointType=TOK_HingeJoint%

TOK_CreateRBCube("CarBody",False,Px#,Py#,Pz# ,90,180,0,1,1,0.5,9,"",255,255,255,1,0)
TOK_ApplyMaterial("CarBody",TOK_TypeRigidBody%,"Plastic")

; ------------------------------
; Create rear left wheel
; ------------------------------
TOK_CreateRBSphere("WheelRearLeft",False,Px#-1.2,-0.7+Py#,Pz#-1.5 ,90,0,0,0.52,5,"",255,0,0,1,0)
TOK_ApplyMaterial("WheelRearLeft",TOK_TypeRigidBody%,"Plastic")

; ---------------------------------
; Create rear right wheel
; ---------------------------------
TOK_CreateRBSphere("WheelRearRight",False,Px#+1.2,-0.7+Py#,Pz#-1.5 ,90,0,0,0.52,5,"",0,255,0,1,0)
TOK_ApplyMaterial("WheelRearRight",TOK_TypeRigidBody%,"Plastic")

; -------------------------------
; Create front left wheel
; -------------------------------
TOK_CreateRBSphere("WheelFrontLeft",False,Px#-1.2,-0.7+Py#,Pz#+1.7 ,90,0,0,0.52,5,"",0,0,255,1,0)
TOK_ApplyMaterial("WheelFrontLeft",TOK_TypeRigidBody%,"Plastic")

; ---------------------------------
; Create front right wheel
; ---------------------------------
TOK_CreateRBSphere("WheelFrontRight",False,Px#+1.2,-0.7+Py#,Pz#+1.7 ,90,0,0,0.52,5,"",255,255,0,1,0)
TOK_ApplyMaterial("WheelFrontRight",TOK_TypeRigidBody%,"Plastic")


; -----------------------
; Create rear axis
; -----------------------
TOK_CreateJoint("RearLeftAxis",2,"WheelRearLeft","CarBody",Px#-1.2,-0.7+Py#,Pz#-1.5,0,0,90,False,JointType,0,-180,180,True,0,10)
TOK_CreateJoint("RearRightAxis",2,"WheelRearRight","CarBody",Px#+1.2,-0.7+Py#,Pz#-1.5,0,0,90,False,JointType,0,-180,180,True,0,10)

; -----------------------------
; Create steering axis
; -----------------------------
TOK_CreateRBCube("WheelFrontLeftConnector",False,Px#-1.2,-0.7+Py#,Pz#+1.7 ,0,0,0,0.1,0.1,0.1,0.1,"",255,255,255,1,0)
TOK_CreateJoint("ConnectorFrontLeftAxis",2,"WheelFrontLeftConnector","CarBody",Px#-1.2,-0.7+Py#,Pz#+1.7,0,0,0,False,JointType,1.5,-45,45,False,0,10)

TOK_CreateRBCube("WheelFrontRightConnector",False,Px#+1.2,-0.7+Py#,Pz#+1.7 ,0,0,0,0.1,0.1,0.1,0.1,"",255,255,255,1,0)
TOK_CreateJoint("ConnectorFrontRightAxis",2,"WheelFrontRightConnector","CarBody",Px#+1.2,-0.7+Py#,Pz#+1.7,0,0,0,False,JointType,1.5,-45,45,False,0,10)

; ------------------------
; Create fornt axis
; ------------------------
TOK_CreateJoint("WheelFrontLeftAxis",2,"WheelFrontLeft","WheelFrontLeftConnector",Px#-1.2,-0.7+Py#,Pz#+1.7,0,0,90,False,JointType,0.5,-180,180)
TOK_CreateJoint("WheelFrontRightAxis",2,"WheelFrontRight","WheelFrontRightConnector",Px#+1.2,-0.7+Py#,Pz#+1.7,0,0,90,False,JointType,0.5,-180,180)

; -------------------------------------------------------------------------------------------
; Create pivot for steering and define the body car for camera 3th
; -------------------------------------------------------------------------------------------
Global Chassi_Mesh=TOK_GetRBMesh("CarBody")
Global Pivot_Temp=CreatePivot()

; ------------------------
; Define some war
; ------------------------
Global Steering_Angle#
Global Car_Acceleration#

; -----------------------------------------------
;	Boucle principale du programme
; -----------------------------------------------
FramePeriod = 1000 / AppFPS
FrameTime = MilliSecs () - FramePeriod
MoveMouse GraphicsWidth()/2, GraphicsHeight()/2

Repeat
	; --------------------------
	; Frame rate limiting
	; --------------------------
	Repeat
		FrameElapsed = MilliSecs () - FrameTime
	Until FrameElapsed

	FrameTicks = FrameElapsed / FramePeriod
	FrameTween# = Float (FrameElapsed Mod FramePeriod) / Float (FramePeriod)

	; -----------------------
	; Update tweening
	; -----------------------
	For FrameLimit = 1 To FrameTicks
		If FrameLimit = FrameTicks Then
			CaptureWorld
		EndIf

		FrameTime = FrameTime + FramePeriod
		
		UpdateGame ()
		UpdateWorld
	Next

	
	; -------------------
	; Redraw world
	; -------------------
	TOK_RefreshEasyTOK()
	RenderWorld FrameTween
	
	; -----------------------
	; FPS Displaying
	; -----------------------
	Proc_CinemaStrip()
	Color 255,255,255
	Information$="<"+Get_FPS()+" FPS> / "+"<Arrow key to move> / <Use directional key to move car> / <Use space to reset car>"
	Text GraphicsWidth()/2,GraphicsHeight()-30,Information$,True,True
	Flip
Until KeyHit (1)

; -------------
; End App
; -------------
TOK_FreePhysic()
FreeFont  AppFont
End

; -------------------------------------
; Tweening update function
; -------------------------------------
Function UpdateGame ()
	Proc_ChaseCam(Cam,Chassi_Mesh,0.1,10,10,10,0)
	Proc_UpdateCar()

	; ---------------------	
	; Update physic
	; ---------------------
	If MouseDown(2)
		TOK_RefreshPhysic(0.2/AppFPS,10)
	Else
		TOK_RefreshPhysic(1.4/AppFPS,10)
	EndIf
End Function

; --------------------------------
; Update car movement
; --------------------------------
Function Proc_UpdateCar()
	; ------------------
	; Car steering
	; ------------------
  	If KeyDown(203) And Steering_Angle#<45 Then
   		Steering_Angle#=Steering_Angle#+0.5
  	ElseIf KeyDown(205) And Steering_Angle#>-45 Then
   		Steering_Angle#=Steering_Angle#-0.5
  	Else
   		If Steering_Angle#>0 Then
     			Steering_Angle#=Steering_Angle#-0.7
   		ElseIf Steering_Angle#<0 Then
     			Steering_Angle#=Steering_Angle#+0.7
   		EndIf
	EndIf


	Tmp_Pitch#=TOK_GetJointPitch#("ConnectorFrontLeftAxis")
	Tmp_Yaw#=TOK_GetJointYaw#("ConnectorFrontLeftAxis")
	Tmp_Roll#=TOK_GetJointRoll#("ConnectorFrontLeftAxis")
		
  	RotateEntity Pivot_Temp,Tmp_Pitch#,Tmp_Yaw#,Tmp_Roll# : TurnEntity Pivot_Temp,0,Steering_Angle#,0,False   
	TOK_RotateRBEntity("WheelFrontLeftConnector",EntityPitch(Pivot_Temp),EntityYaw(Pivot_Temp),EntityRoll(Pivot_Temp))

	Tmp_Pitch#=TOK_GetJointPitch#("ConnectorFrontRightAxis")
	Tmp_Yaw#=TOK_GetJointYaw#("ConnectorFrontRightAxis")
	Tmp_Roll#=TOK_GetJointRoll#("ConnectorFrontRightAxis")
		
  	RotateEntity Pivot_Temp,Tmp_Pitch#,Tmp_Yaw#,Tmp_Roll# : TurnEntity Pivot_Temp,0,Steering_Angle#,0,False   
	TOK_RotateRBEntity("WheelFrontRightConnector",EntityPitch(Pivot_Temp),EntityYaw(Pivot_Temp),EntityRoll(Pivot_Temp))

	; -----------------------
	; Car acceleration
	; -----------------------
 	If KeyDown(200) Then
  		Car_Acceleration#=60.0
 	ElseIf KeyDown(208) Then
  		Car_Acceleration#=-50.0
 	Else
  		Car_Acceleration#=Car_Acceleration#*0.05
 	EndIf

		; Faking some kind of differential (For better steering)
  		Left_Wheel_Boost#=1-Steering_Angle#*0.02
  		Right_Wheel_Boost#=1+Steering_Angle#*0.02

		Tmp_Pitch#=TOK_GetJointPitch#("RearLeftAxis")
		Tmp_Yaw#=TOK_GetJointYaw#("RearLeftAxis")
		Tmp_Roll#=TOK_GetJointRoll#("RearLeftAxis")
	
  		RotateEntity Pivot_Temp,Tmp_Pitch#,Tmp_Yaw#,Tmp_Roll# -90
  		TFormVector Car_Acceleration#*Left_Wheel_Boost#,0,0,Pivot_Temp,0  
		TOK_ApplyTorque("WheelRearLeft",TFormedX#(),TFormedY#(),TFormedZ#())

		Tmp_Pitch#=TOK_GetJointPitch#("RearRightAxis")
		Tmp_Yaw#=TOK_GetJointYaw#("RearRightAxis")
		Tmp_Roll#=TOK_GetJointRoll#("RearRightAxis")
		
  		RotateEntity Pivot_Temp,Tmp_Pitch#,Tmp_Yaw#,Tmp_Roll# -90
 		TFormVector Car_Acceleration#*Right_Wheel_Boost#,0,0,Pivot_Temp,0
		TOK_ApplyTorque("WheelRearRight",TFormedX#(),TFormedY#(),TFormedZ#())


  		If KeyDown(57) Then
			Tmp_Px#=TOK_GetRBX#("CarBody")
			Tmp_Py#=TOK_GetRBY#("CarBody")
			Tmp_Pz#=TOK_GetRBZ#("CarBody")
			TOK_ApplyForce2("CarBody",0,250,0,Tmp_Px#+5,Tmp_Py#,Tmp_Pz#)
  		Else
			TOK_ApplyForce2("CarBody",0,0,0,0,0,0)
  		EndIf
End Function 

; --------------------
; Camera mario
; --------------------
Function Proc_ChaseCam(CamEntity,Entity,CamSpeed#,Distance#,Hauteur#,RotX#,RotZ#)
	TFormPoint 0,Hauteur#,-Distance#,Entity,0
	
	cx#=(TFormedX()-EntityX(CamEntity))*CamSpeed#
	cy#=(TFormedY()-EntityY(CamEntity))*CamSpeed#
	cz#=(TFormedZ()-EntityZ(CamEntity))*CamSpeed#
	
	TranslateEntity CamEntity,cx,cy,cz
	PointEntity CamEntity,Entity
	RotateEntity CamEntity,RotX#,EntityYaw(CamEntity,True),RotZ#
End Function

; -----------------------
; Create the visor
; -----------------------
Function Proc_CreateVisor()
	Visor=LoadSprite("./ETOK_Medias/Target.png")
	PositionEntity Visor,EntityX(Cam),EntityY(Cam),EntityZ(Cam)+2
	ScaleSprite Visor,0.1,0.1
	EntityParent Visor,Cam
	EntityOrder Visor,-1
End Function

; ----------------------------------
; Create the cinema strip
; ----------------------------------
Function Proc_CinemaStrip(Size=60)
	Color 1,1,1
	Rect 0,0,GraphicsWidth(),Size
	Rect 0,GraphicsHeight()-Size,GraphicsWidth(),Size
End Function