;=======================================================================================
; Code : EasyTok librarie example
; Project Title : EasyTok librarie example
; Author : Philippe Agnisola
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_TimeMachine.bb"
Include "Inc_EasyTOK.bb"

; ------------------------
; Freelook cam var
; ------------------------
Global Mouse_X_Speed#
Global Mouse_Y_Speed#
Global Camera_VelX#
Global Camera_VelZ#
Global Camera_Pitch
Global Camera_Yaw

; -------------------------------
; Refresh frame number
; -------------------------------
Global AppFPS =60

; ------------------
; Open screen
; ------------------
Graphics3D 1024, 768,32
SetBuffer BackBuffer ()

; ----------------------
; Change font text
; ----------------------
AppFont=LoadFont("Arial",15,1,0,0) 
SetFont AppFont

; -------------------------------------
; Setup camera and Easytok
; -------------------------------------
Global Cam=CreateCamera()
PositionEntity Cam,0,20,-40

Proc_CreateVisor()
 
TOK_InitWorld(0,-41,0,1000,100)
TOK_CreateGround("Floor",300,255,150,10)
TOK_ApplyMaterial("Floor",TOK_TypeAnimatedBody%,"Ice")

; -----------------------------
; Creating demo world
; -----------------------------
Global Light1=CreateLight(2)
PositionEntity Light1,-50,50,-50
LightColor Light1,250,150,50
LightRange Light1,100

Global Light2=CreateLight(2)
PositionEntity Light2,50,50,50
LightColor Light2,50,150,250
LightRange Light2,100

AmbientLight 80,90,100

Px#=0 : Py#=25 : Pz#=0
JointType1=TOK_BallJoint%
JointType2=TOK_HingeJoint%
Mass=5

; ---------------------------------------------------------------------
; The bar and the joint where the ragdoll attached
; ---------------------------------------------------------------------
TOK_CreateRBCube("Bar01",False,Px#-8,Py#+11,Pz#,0,0,0,8,1,1,Mass,"",255,255,255,1,0)
TOK_CreateJoint("BarJoint01",1,"Bar01","Bar01",Px#-8,Py#+13,Pz#,0,0,90,1,JointType1,100,0,0)

; --------------------------------
; Define the ragdoll part
; --------------------------------
TOK_CreateRBSphere("Head",False,Px#,Py#,Pz#,0,0,0,2,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint00",2,"Head","Bar01",Px#+1,Py#+11,Pz#,0,0,0,1,JointType1,100,-180,180)

TOK_CreateRBCube("Torso",False,Px#,Py#-5,Pz#,0,0,0,2,3,1,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint01",2,"Head","Torso",Px#,Py#-2,Pz#,0,0,90,1,JointType2,100,-45,45)

TOK_CreateRBCube("Pelvis",False,Px#,Py#-10,Pz#,0,0,0,2,1.5,1,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint02",2,"Torso","Pelvis",Px#,Py#-8,Pz#,0,0,90,1,JointType2,100,-30,60)

TOK_CreateRBCube("LeftArm1",False,Px#-5,Py#-4.5,Pz#,0,0,-45,0.5,2.5,0.5,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint03",2,"Torso","LeftArm1",Px#-2.5,Py#-2.5,Pz#,90,0,0,1,JointType1,100,-60,40)

TOK_CreateRBCube("RightArm1",False,Px#+5,Py#-4.5,Pz#,0,0,45,0.5,2.5,0.5,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint05",2,"Torso","RightArm1",Px#+2.5,Py#-2.5,Pz#,90,0,0,1,JointType1,100,-60,40)

TOK_CreateRBCube("LeftArm2",False,Px#-9,Py#-8.5,Pz#,0,0,-45,0.5,2.5,0.5,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint04",2,"LeftArm1","LeftArm2",Px#-7,Py#-6.5,Pz#,0,0,0,1,JointType2,100,-60,40)

TOK_CreateRBCube("RightArm2",False,Px#+9,Py#-8.5,Pz#,0,0,45,0.5,2.5,0.5,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint06",2,"RightArm1","RightArm2",Px#+7,Py#-6.5,Pz#,0,0,0,1,JointType2,100,-60,40)

TOK_CreateRBCube("LeftLeg1",False,Px#-2,Py#-15,Pz#,0,0,0,0.7,2.5,0.7,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint07",2,"LeftLeg1","Pelvis",Px#-2,Py#-12,Pz#,0,0,90,1,JointType2,100,-45,90)

TOK_CreateRBCube("RightLeg1",False,Px#+2,Py#-15,Pz#,0,0,0,0.7,2.5,0.7,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint08",2,"RightLeg1","Pelvis",Px#+2,Py#-12,Pz#,0,0,90,1,JointType2,100,-45,90)

TOK_CreateRBCube("LeftLeg2",False,Px#-2,Py#-21,Pz#,0,0,0,0.7,2.5,0.7,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint09",2,"LeftLeg2","LeftLeg1",Px#-2,Py#-18,Pz#,0,0,90,1,JointType2,100,0,150)

TOK_CreateRBCube("RightLeg2",False,Px#+2,Py#-21,Pz#,0,0,0,0.7,2.5,0.7,Mass,"",255,255,255,1,0)
TOK_CreateJoint("Joint10",2,"RightLeg2","RightLeg1",Px#+2,Py#-18,Pz#,0,0,90,1,JointType2,100,0,150)

; -------------
; Main loop
; -------------
FramePeriod = 1000 / AppFPS
FrameTime = MilliSecs () - FramePeriod
MoveMouse GraphicsWidth()/2, GraphicsHeight()/2

Repeat
	; --------------------------
	; Frame rate limiting
	; --------------------------
	Repeat
		FrameElapsed = MilliSecs () - FrameTime
	Until FrameElapsed

	FrameTicks = FrameElapsed / FramePeriod
	FrameTween# = Float (FrameElapsed Mod FramePeriod) / Float (FramePeriod)

	; -----------------------
	; Update tweening
	; -----------------------
	For FrameLimit = 1 To FrameTicks
		If FrameLimit = FrameTicks Then
			CaptureWorld
		EndIf

		FrameTime = FrameTime + FramePeriod
		
		UpdateGame ()
		UpdateWorld
	Next

	; -------------------
	; Redraw world
	; -------------------
	TOK_RefreshEasyTOK()
	RenderWorld FrameTween
	
	; ---------------------
	; FPS Displaying
	; ---------------------
	Proc_CinemaStrip()
	Color 255,255,255
	Information$="<"+Get_FPS()+" FPS> / "+"<Arrow key to move> / <Mouse left to turn the man> / <Mouse right matrix mode> / <Mouse meedle launch man>"
	Text GraphicsWidth()/2,GraphicsHeight()-30,Information$,True,True
	Flip
Until KeyHit (1)

; -----------
; End App
; -----------
TOK_FreePhysic()
FreeFont  AppFont
End

; -----------------------------------
; Tweening update function
; -----------------------------------
Function UpdateGame ()
	Proc_Freelook(Cam,1.05,0.05)

	TOK_ApplyImpulse("LeftArm2",Rnd(-50,50),Rnd(-50,50),Rnd(-50,50))
	TOK_ApplyImpulse("RightArm2",Rnd(-50,50),Rnd(-50,50),Rnd(-50,50))
	TOK_ApplyImpulse("Torso",0,0,Rnd(-100,100))
	
	If MouseDown(1) Then
		TOK_ApplyTwist("Bar01",0,3500,0)
		TOK_EnableJoint("Joint00",True)
	EndIf
	
	If MouseHit(3) Then
		TOK_EnableJoint("Joint00",False)
	EndIf

	; ---------------------	
	; Update physic
	; ---------------------
	If MouseDown(2)
		TOK_RefreshPhysic(0.3/AppFPS,10)
	Else
		TOK_RefreshPhysic(1.7/AppFPS,10)
	EndIf 
End Function

; -----------------------
; Create the visor
; -----------------------
Function Proc_CreateVisor()
	Visor=LoadSprite("./ETOK_Medias/Target.png")
	PositionEntity Visor,EntityX(Cam),EntityY(Cam),EntityZ(Cam)+2
	ScaleSprite Visor,0.1,0.1
	EntityParent Visor,Cam
	EntityOrder Visor,-1
End Function

; ----------------------------------
; Create the cinema strip
; ----------------------------------
Function Proc_CinemaStrip(Size=60)
	Color 1,1,1
	Rect 0,0,GraphicsWidth(),Size
	Rect 0,GraphicsHeight()-Size,GraphicsWidth(),Size
End Function

; ----------------------
; Camera freelook
; ----------------------
Function Proc_Freelook(CamEntity,Velocity#,Speed#)
	Mouse_X_Speed#=MouseXSpeed()*0.5
	Mouse_Y_Speed#=MouseYSpeed()*0.5

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	Camera_Pitch=Camera_Pitch+Mouse_Y_Speed#
	Camera_Yaw=Camera_Yaw+Mouse_X_Speed#

	RotateEntity CamEntity,Camera_Pitch,-Camera_Yaw,0

	If KeyDown(203) Then
		Camera_VelX=Camera_VelX-Speed#
	ElseIf  KeyDown(205)
		Camera_VelX=Camera_VelX+Speed#
	EndIf
	
	If KeyDown(208) Then
		Camera_VelZ=Camera_VelZ-Speed#
	ElseIf  KeyDown(200)
		Camera_VelZ=Camera_VelZ+Speed#
	EndIf
 
	Camera_VelX=Camera_VelX/velocity#
	Camera_VelZ=Camera_VelZ/velocity#
	MoveEntity CamEntity,Camera_VelX,0,Camera_VelZ

	If KeyDown(200) Then
		MoveEntity CamEntity,0,0,Speed#
	EndIf

	If KeyDown(208) Then
		MoveEntity CamEntity,0,0,-Speed#
	EndIf

	If KeyDown(205) Then
		MoveEntity CamEntity,Speed#,0,0
	EndIf

	If KeyDown(203) Then
		MoveEntity CamEntity,-Speed#,0,0
	EndIf
End Function