;=======================================================================================
; Code : EasyTok librarie example
; Project Title : EasyTok librarie example
; Author : Philippe Agnisola
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_TimeMachine.bb"
Include "Inc_EasyTOK.bb"

; ------------------------
; Freelook cam var
; ------------------------
Global Mouse_X_Speed#
Global Mouse_Y_Speed#
Global Camera_VelX#
Global Camera_VelZ#
Global Camera_Pitch
Global Camera_Yaw

; -------------------------------
; Refresh frame number
; -------------------------------
Global AppFPS =60

; ------------------
; Open screen
; ------------------
Graphics3D 1024, 768,32
SetBuffer BackBuffer ()

; ----------------------
; Change font text
; ----------------------
AppFont=LoadFont("Arial",15,1,0,0) 
SetFont AppFont

; ---------------------------------------
; Setup camera and Easytok
; ---------------------------------------
Global Cam=CreateCamera()
PositionEntity Cam,0,20,-40
EntityRadius Cam,3
EntityType Cam,1

Proc_CreateVisor()

TOK_InitWorld(0,-41,0,1000,100)

; -----------------------------
; Creating demo world
; -----------------------------
Global Light1=CreateLight(2)
PositionEntity Light1,-50,50,-50
LightColor Light1,200,100,50
LightRange Light1,60

Global Light2=CreateLight(2)
PositionEntity Light2,50,50,50
LightColor Light2,50,200,50
LightRange Light2,60

AmbientLight 50,50,60

; ----------------------------------------------------
; Load the tokamak world from a B3D
; ----------------------------------------------------
TOK_CreatePhysicFromMesh(LoadAnimMesh("./ETOK_Medias/Room01.b3d"))
Collisions 1,2,2,3

TOK_CreateRagdoll("Doll01",60,25,-25)
TOK_CreateRagdoll("Doll02",-60,25,-25)


; --------------------------------
; Define the ragdoll part
; --------------------------------
Type TOK_Ragdoll
	Field Ragdoll_Name$
	Field Ragdoll_Mass#
	
	Field Ragdoll_Px#
	Field Ragdoll_Py#
	Field Ragdoll_Pz#
	
	Field Part_Head
	Field Part_Torso
	Field Part_Pelvis
	
	Field Part_Left_Arm_01
	Field Part_Right_Arm_01

	Field Part_Left_Arm_02
	Field Part_Right_Arm_02

	Field Part_Left_Leg_01
	Field Part_Right_Leg_01

	Field Part_Left_Leg_02
	Field Part_Right_Leg_02
End Type

; ------------------------------------------------------
; This is an example of ragdoll structur
; ------------------------------------------------------
Function TOK_CreateRagdoll(Name$,Px#,Py#,Pz#)
		R.TOK_Ragdoll = New TOK_Ragdoll
		R\Ragdoll_Name$=Name$
		R\Ragdoll_Mass#=5

		R\Ragdoll_Px#=Px#
		R\Ragdoll_Py#=Py#
		R\Ragdoll_Pz#=Pz#

		R\Part_Head=TOK_CreateRBSphere(Name$+"_"+"Head",False,Px#,Py#,Pz#,0,0,0,2,R\Ragdoll_Mass#,"",255,255,255,1,0)
		R\Part_Torso=TOK_CreateRBCube(Name$+"_"+"Torso",False,Px#,Py#-5,Pz#,0,0,0,2,3,1,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint01",2,Name$+"_"+"Head",Name$+"_"+"Torso",Px#,Py#-2,Pz#,0,0,90,1,TOK_HingeJoint%,100,-45,45)
		
		R\Part_Pelvis=TOK_CreateRBCube(Name$+"_"+"Pelvis",False,Px#,Py#-10,Pz#,0,0,0,2,1.5,1,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint02",2,Name$+"_"+"Torso",Name$+"_"+"Pelvis",Px#,Py#-8,Pz#,0,0,90,1,TOK_HingeJoint%,100,-30,60)
	
		R\Part_Left_Arm_01=TOK_CreateRBCube(Name$+"_"+"LeftArm1",False,Px#-5,Py#-4.5,Pz#,0,0,-45,0.5,2.5,0.5,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint03",2,Name$+"_"+"Torso",Name$+"_"+"LeftArm1",Px#-2.5,Py#-2.5,Pz#,90,0,0,1,TOK_BallJoint%,100,-60,40)
		
		R\Part_Right_Arm_01=TOK_CreateRBCube(Name$+"_"+"RightArm1",False,Px#+5,Py#-4.5,Pz#,0,0,45,0.5,2.5,0.5,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint05",2,Name$+"_"+"Torso",Name$+"_"+"RightArm1",Px#+2.5,Py#-2.5,Pz#,90,0,0,1,TOK_BallJoint%,100,-60,40)

		R\Part_Left_Arm_02=TOK_CreateRBCube(Name$+"_"+"LeftArm2",False,Px#-9,Py#-8.5,Pz#,0,0,-45,0.5,2.5,0.5,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint04",2,Name$+"_"+"LeftArm1",Name$+"_"+"LeftArm2",Px#-7,Py#-6.5,Pz#,0,0,0,1,TOK_HingeJoint%,100,-60,40)
		
		R\Part_Right_Arm_02=TOK_CreateRBCube(Name$+"_"+"RightArm2",False,Px#+9,Py#-8.5,Pz#,0,0,45,0.5,2.5,0.5,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint06",2,Name$+"_"+"RightArm1",Name$+"_"+"RightArm2",Px#+7,Py#-6.5,Pz#,0,0,0,1,TOK_HingeJoint%,100,-60,40)

		R\Part_Left_Leg_01=TOK_CreateRBCube(Name$+"_"+"LeftLeg1",False,Px#-2,Py#-15,Pz#,0,0,0,0.7,2.5,0.7,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint07",2,Name$+"_"+"LeftLeg1",Name$+"_"+"Pelvis",Px#-2,Py#-12,Pz#,0,0,90,1,TOK_HingeJoint%,100,-45,90)
		
		R\Part_Right_Leg_01=TOK_CreateRBCube(Name$+"_"+"RightLeg1",False,Px#+2,Py#-15,Pz#,0,0,0,0.7,2.5,0.7,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint08",2,Name$+"_"+"RightLeg1",Name$+"_"+"Pelvis",Px#+2,Py#-12,Pz#,0,0,90,1,TOK_HingeJoint%,100,-45,90)

		R\Part_Left_Leg_02=TOK_CreateRBCube(Name$+"_"+"LeftLeg2",False,Px#-2,Py#-21,Pz#,0,0,0,0.7,2.5,0.7,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint09",2,Name$+"_"+"LeftLeg2",Name$+"_"+"LeftLeg1",Px#-2,Py#-18,Pz#,0,0,90,1,TOK_HingeJoint%,100,0,150)
		
		R\Part_Right_Leg_02=TOK_CreateRBCube(Name$+"_"+"RightLeg2",False,Px#+2,Py#-21,Pz#,0,0,0,0.7,2.5,0.7,R\Ragdoll_Mass#,"",255,255,255,1,0)
		TOK_CreateJoint(Name$+"Joint10",2,Name$+"_"+"RightLeg2",Name$+"_"+"RightLeg1",Px#+2,Py#-18,Pz#,0,0,90,1,TOK_HingeJoint%,100,0,150)

		TOK_ApplyForce(Name$+"_"+"Head",0,1950,0)
End Function 

; -------------
; Main loop
; -------------
FramePeriod = 1000 / AppFPS
FrameTime = MilliSecs () - FramePeriod
MoveMouse GraphicsWidth()/2, GraphicsHeight()/2

Global MyShootRate=200
Global MyShootTimer=TOK_CreateTimer( MyShootRate)

Repeat
	; --------------------------
	; Frame rate limiting
	; --------------------------
	Repeat
		FrameElapsed = MilliSecs () - FrameTime
	Until FrameElapsed

	FrameTicks = FrameElapsed / FramePeriod
	FrameTween# = Float (FrameElapsed Mod FramePeriod) / Float (FramePeriod)

	; -----------------------
	; Update tweening
	; -----------------------
	For FrameLimit = 1 To FrameTicks
		If FrameLimit = FrameTicks Then
			CaptureWorld
		EndIf

		FrameTime = FrameTime + FramePeriod
		
		UpdateGame ()
		UpdateWorld
	Next

	; -------------------
	; Redraw world
	; -------------------
	TOK_RefreshEasyTOK()
	RenderWorld FrameTween
	
	; -----------------------
	; FPS Displaying
	; -----------------------
	Proc_CinemaStrip()
	Color 255,255,255
	Information$="<"+Get_FPS()+" FPS> / "+"<Arrow key to move> / <Mouse left to shoot>"
	Text GraphicsWidth()/2,GraphicsHeight()-30,Information$,True,True
	Flip
Until KeyHit (1)

; -----------
; End App
; -----------
TOK_FreePhysic()
FreeFont  AppFont
End

; -----------------------------------
; Tweening update function
; -----------------------------------
Function UpdateGame ()
	Proc_Freelook(Cam,1.05,0.05)
	
	If MouseDown(1) Then
		If  TOK_TimeOut(MyShootTimer) Then
		
			Tmp$="Bullet"+Rnd(1000)
			TOK_CreateRBSphere(Tmp$,False,EntityX(Cam),EntityY(Cam),EntityZ(Cam),EntityPitch(Cam),EntityYaw(cam),EntityRoll(cam),2,6,"",Rnd(255),Rnd(255),Rnd(255),1,3)
			TOK_ApplyImpulseWithAngle(Tmp$,EntityPitch(Cam),EntityYaw(cam),1100)
			TOK_ApplyMaterial(Tmp$,TOK_TypeRigidBody%,"Metal")
	
			MyShootTimer=TOK_CreateTimer( MyShootRate)
		EndIf
	EndIf

	If MouseHit(2) Then
		TOK_ApplyImpulse("MYBALL01",Rnd(-450,450),Rnd(-150,150),Rnd(-450,450))
	EndIf

	; -----------------------------------------------------------
	; Define if the camera collide a toka object
	; -----------------------------------------------------------
	Local Power=600
	
	If CountCollisions(Cam)>0 Then
		For k=1 To CountCollisions(cam)
			Entity_Collided=CollisionEntity(Cam,k)

			If TOK_IsRigidBody(Entity_Collided)=True Then
				TOK_ApplyImpulse2(TOK_GetRBName$(Entity_Collided),-Power*CollisionNX(Cam,k),-Power*CollisionNY(Cam,k),-Power*CollisionNZ(Cam,k),CollisionX(Cam,k),CollisionY(Cam,k),CollisionZ(Cam,k))
			EndIf
		Next
	EndIf

	; ---------------------	
	; Update physic
	; ---------------------
	TOK_RefreshPhysic(1.7/AppFPS,5)
End Function

; -----------------------
; Create the visor
; -----------------------
Function Proc_CreateVisor()
	Visor=LoadSprite("./ETOK_Medias/Target.png")
	PositionEntity Visor,EntityX(Cam),EntityY(Cam),EntityZ(Cam)+2
	ScaleSprite Visor,0.1,0.1
	EntityParent Visor,Cam
	EntityOrder Visor,-1
End Function

; ----------------------------------
; Create the cinema strip
; ----------------------------------
Function Proc_CinemaStrip(Size=60)
	Color 1,1,1
	Rect 0,0,GraphicsWidth(),Size
	Rect 0,GraphicsHeight()-Size,GraphicsWidth(),Size
End Function

; ----------------------
; Camera freelook
; ----------------------
Function Proc_Freelook(CamEntity,Velocity#,Speed#)
	Mouse_X_Speed#=MouseXSpeed()*0.5
	Mouse_Y_Speed#=MouseYSpeed()*0.5

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	Camera_Pitch=Camera_Pitch+Mouse_Y_Speed#
	Camera_Yaw=Camera_Yaw+Mouse_X_Speed#

	RotateEntity CamEntity,Camera_Pitch,-Camera_Yaw,0

	If KeyDown(203) Then
		Camera_VelX=Camera_VelX-Speed#
	ElseIf  KeyDown(205)
		Camera_VelX=Camera_VelX+Speed#
	EndIf
	
	If KeyDown(208) Then
		Camera_VelZ=Camera_VelZ-Speed#
	ElseIf  KeyDown(200)
		Camera_VelZ=Camera_VelZ+Speed#
	EndIf
 
	Camera_VelX=Camera_VelX/velocity#
	Camera_VelZ=Camera_VelZ/velocity#
	MoveEntity CamEntity,Camera_VelX,0,Camera_VelZ

	If KeyDown(200) Then
		MoveEntity CamEntity,0,0,Speed#
	EndIf

	If KeyDown(208) Then
		MoveEntity CamEntity,0,0,-Speed#
	EndIf

	If KeyDown(205) Then
		MoveEntity CamEntity,Speed#,0,0
	EndIf

	If KeyDown(203) Then
		MoveEntity CamEntity,-Speed#,0,0
	EndIf
End Function