;=======================================================================================
; Code :
; Project Title :
; Author : Philippe Agnisola
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_TimeMachine.bb"
Include "Inc_EasyTOK.bb"

; ------------------------
; Freelook cam var
; ------------------------
Global Mouse_X_Speed#
Global Mouse_Y_Speed#
Global Camera_VelX#
Global Camera_VelZ#
Global Camera_Pitch
Global Camera_Yaw

; ------------------------------
; Nombre d'image MAX
; ------------------------------
Global AppFPS =60

; -------------------
; Open screen
; -------------------
Graphics3D 1024, 768,32,0
SetBuffer BackBuffer ()

; -------------------
; Loadong font
; -------------------
AppFont=LoadFont("Arial",15,1,0,0) 
SetFont AppFont

; ----------------------------------------
; Setup camera and Easytok
; ----------------------------------------
Global Cam=CreateCamera()
PositionEntity Cam,0,30,-40
CameraRange Cam,0.1,3000

Proc_CreateVisor()

TOK_InitWorld(0,-80,0,1000,100)
TOK_CreateGround("Floor",950,255,200,100)

; -----------------------------
; Creating demo world
; -----------------------------
Global Light1=CreateLight(2)
PositionEntity Light1,-50,50,-50
LightColor Light1,250,150,50
LightRange Light1,600

Global Light2=CreateLight(2)
PositionEntity Light2,50,50,50
LightColor Light2,50,150,250
LightRange Light2,600

AmbientLight 80,90,100

; ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Load the animated imp and create ragdoll, note : in the function Proc_MakeRagdoll the Seed$ parameter is needed if you want multiple ragdoll
; you can specify any name, in the example i have used "One" and "Two" but you can use any name :) but there is a FPS problem when you try
; To make more than 3 ragdoll :( And i don't know why ... Maybe a tokamak problem ? Or a blitz problem, i'm waiting bmax engine too ...
; ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Global MyMesh01=LoadAnimMesh("./ETOK_Medias/RagDoll02.b3d")
PositionEntity MyMEsh01,-50,10,0
Proc_MakeRagdoll(MyMesh01,"One")

Global MyMesh02=LoadAnimMesh("./ETOK_Medias/RagDoll02.b3d")
PositionEntity MyMesh02,50,10,0
Proc_MakeRagdoll(MyMesh02,"Two")


; ------------------------------------------------
;	Boucle principale du programme
; ------------------------------------------------
FramePeriod = 1000 / AppFPS
FrameTime = MilliSecs () - FramePeriod
MoveMouse GraphicsWidth()/2, GraphicsHeight()/2

Repeat
	TOK_RefreshEasyTOK()

	; --------------------------
	; Frame rate limiting
	; --------------------------
	Repeat
		FrameElapsed = MilliSecs () - FrameTime
	Until FrameElapsed

	FrameTicks = FrameElapsed / FramePeriod
	FrameTween# = Float (FrameElapsed Mod FramePeriod) / Float (FramePeriod)

	; -----------------------
	; Update tweening
	; -----------------------
	For FrameLimit = 1 To FrameTicks
		If FrameLimit = FrameTicks Then
			CaptureWorld
		EndIf

		FrameTime = FrameTime + FramePeriod
		
		UpdateGame ()
		UpdateWorld
	Next

	
	; -------------------
	; Redraw world
	; -------------------
	RenderWorld FrameTween
	
	; ---------------------
	; FPS Displaying
	; ---------------------
	Proc_CinemaStrip()
	Color 255,255,255
	Information$="<"+Get_FPS()+" FPS> / "+"< Press left mouse to move ragdoll imp :) >"
	Text GraphicsWidth()/2,GraphicsHeight()-30,Information$,True,True
	Flip False
Until KeyHit (1)

; -------------
; End App
; -------------
TOK_FreePhysic()
FreeFont  AppFont
End

; -------------------------------------
; Tweening update function
; -------------------------------------
Function UpdateGame ()
	Proc_Freelook(Cam,1.05,0.05)

	; ----------------------------------------------------------------------------------
	; Apply an impulse to the end joint of the head of each imp
	; ----------------------------------------------------------------------------------
	If MouseDown(1) Then
		TOK_ApplyImpulse("RD_HeadEnd"+"One",0,Rnd(130,185),0)
	EndIf

	If MouseDown(2) Then	
		TOK_ApplyImpulse("RD_HeadEnd"+"Two",0,Rnd(130,185),0)
	EndIf
	
	; ---------------------	
	; Update physic
	; ---------------------
	TOK_RefreshPhysic(1.7/AppFPS,10)
End Function

; ----------------------
; Camera freelook
; ----------------------
Function Proc_Freelook(CamEntity,Velocity#,Speed#)
 Mouse_X_Speed#=MouseXSpeed()*0.5
 Mouse_Y_Speed#=MouseYSpeed()*0.5

 MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
 Camera_Pitch=Camera_Pitch+Mouse_Y_Speed#
 Camera_Yaw=Camera_Yaw+Mouse_X_Speed#


 RotateEntity CamEntity,Camera_Pitch,-Camera_Yaw,0

 If KeyDown(203) Then
   Camera_VelX=Camera_VelX-Speed#
 ElseIf  KeyDown(205)
   Camera_VelX=Camera_VelX+Speed#
 EndIf
 If KeyDown(208) Then
   Camera_VelZ=Camera_VelZ-Speed#
 ElseIf  KeyDown(200)
   Camera_VelZ=Camera_VelZ+Speed#
 EndIf
 
 Camera_VelX=Camera_VelX/velocity#
 Camera_VelZ=Camera_VelZ/velocity#
 MoveEntity CamEntity,Camera_VelX,0,Camera_VelZ

 If KeyDown(200) Then
   MoveEntity CamEntity,0,0,Speed#
 EndIf

 If KeyDown(208) Then
   MoveEntity CamEntity,0,0,-Speed#
 EndIf

 If KeyDown(205) Then
   MoveEntity CamEntity,Speed#,0,0
 EndIf

 If KeyDown(203) Then
   MoveEntity CamEntity,-Speed#,0,0
 EndIf
End Function

; -----------------------
; Create the visor
; -----------------------
Function Proc_CreateVisor()
	Visor=LoadSprite("./ETOK_Medias/Target.png")
	PositionEntity Visor,EntityX(Cam),EntityY(Cam),EntityZ(Cam)+2
	ScaleSprite Visor,0.1,0.1
	EntityParent Visor,Cam
	EntityOrder Visor,-1
End Function

; ----------------------------------
; Create the cinema strip
; ----------------------------------
Function Proc_CinemaStrip(Size=60)
	Color 1,1,1
	Rect 0,0,GraphicsWidth(),Size
	Rect 0,GraphicsHeight()-Size,GraphicsWidth(),Size
End Function






; --------------------------------------------------------
; Create the ragdoll from animated mesh
; --------------------------------------------------------
Function Proc_MakeRagdoll(MyMesh,Seed$)
		; ---------------------------------------------------
		; Var for joint and cube look and size
		; ---------------------------------------------------
		Scale#=3 : Alpha#=0 : View=0
		
		; ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		; Mesh body (Pelvis, Spine 01, Spine 02) Note : It's needed for create the first joint ! because i need connection for this first joint
		; ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		RD_Pelvis=Proc_GetChildMesh(MyMesh,"Bone01","Pivot")
		TOK_CreateRBCube("RD_Pelvis"+Seed$,False,EntityX(RD_Pelvis,True),EntityY(RD_Pelvis,True),EntityZ(RD_Pelvis,True),0,0,0,Scale#,Scale#,Scale#,1,"",255,255,255,1,0)
		TOK_EntityAlpha("RD_Pelvis"+Seed$,Alpha#)

		RD_Spine01=Proc_GetChildMesh(MyMesh,"Bone02","Pivot")
		TOK_CreateRBCube("RD_Spine01"+Seed$,False,EntityX(RD_Spine01,True),EntityY(RD_Spine01,True),EntityZ(RD_Spine01,True),0,0,0,Scale#,Scale#,Scale#,1,"",255,255,255,1,0)
		TOK_EntityAlpha("RD_Spine01"+Seed$,Alpha#)

		RD_Joint01=Proc_GetChildMesh(MyMesh,"Bone02","Pivot")
		TOK_CreateJoint("RD_Joint01",2,"RD_Pelvis"+Seed$,"RD_Spine01"+Seed$,EntityX(RD_Joint01,True),EntityY(RD_Joint01,True),EntityZ(RD_Joint01,True),90,0,0,View,TOK_HingeJoint%,100,-20,20)
		
		; --------
		; Head
		; --------
		RD_Spine02=Proc_MakeRagdollJoint(MyMesh,"Bone03","RD_Spine02"+Seed$,"RD_Spine01"+Seed$,3,TOK_HingeJoint%,90,0,0,-20,20); Colonne vertebrale
		RD_Head=Proc_MakeRagdollJoint(MyMesh,"Bone04","RD_Head"+Seed$,"RD_Spine02"+Seed$,3,TOK_HingeJoint%,90,0,0,-40,40); Tete
		RD_HeadEnd=Proc_MakeRagdollJoint(MyMesh,"Bone05","RD_HeadEnd"+Seed$,"RD_Head"+Seed$,2,TOK_HingeJoint%,90,0,0,-20,20); Haut Tete

		; -------------
		; Left Arm
		; -------------
		RD_LeftClavicle=Proc_MakeRagdollJoint(MyMesh,"Bone12","RD_LeftClavicle"+Seed$,"RD_Spine02"+Seed$,3,TOK_HingeJoint%,0,0,-90,0,0); Epaule gauche
		RD_LeftUpperArm=Proc_MakeRagdollJoint(MyMesh,"Bone13","RD_LeftUpperArm"+Seed$,"RD_LeftClavicle"+Seed$,3,TOK_HingeJoint%,0,0,-90,-60,60); Bras gauche
		RD_LeftForeArm=Proc_MakeRagdollJoint(MyMesh,"Bone14","RD_LeftForeArm"+Seed$,"RD_LeftUpperArm"+Seed$,3,TOK_HingeJoint%,0,90,0,10,70); Avant bras gauche
		RD_LeftHand=Proc_MakeRagdollJoint(MyMesh,"Bone15","RD_LeftHand"+Seed$,"RD_LeftForeArm"+Seed$,3,TOK_HingeJoint%,0,0,-90,-50,50); Main gauche
		RD_LeftHandEnd=Proc_MakeRagdollJoint(MyMesh,"Bone16","RD_LeftHandEnd"+Seed$,"RD_LeftHand"+Seed$,2); Main gauche fin
		
		; ---------------
		; Right Arm
		; ---------------
		RD_RightClavicle=Proc_MakeRagdollJoint(MyMesh,"Bone07","RD_RightClavicle"+Seed$,"RD_Spine02"+Seed$,3,TOK_HingeJoint%,0,0,-90,00); Epaule droite
		RD_RightUpperArm=Proc_MakeRagdollJoint(MyMesh,"Bone08","RD_RightUpperArm"+Seed$,"RD_RightClavicle"+Seed$,3,TOK_HingeJoint%,0,0,-90,-60,60); Bras droit
		RD_RightForeArm=Proc_MakeRagdollJoint(MyMesh,"Bone09","RD_RightForeArm"+Seed$,"RD_RightUpperArm"+Seed$,3,TOK_HingeJoint%,0,90,0,10,70); Avant bras droit
		RD_RightHand=Proc_MakeRagdollJoint(MyMesh,"Bone10","RD_RightHand"+Seed$,"RD_RightForeArm"+Seed$,3,TOK_HingeJoint%,0,0,-90,-50,50); Main droite
		RD_RightHandEnd=Proc_MakeRagdollJoint(MyMesh,"Bone11","RD_RightHandEnd"+Seed$,"RD_RightHand"+Seed$,2); Main droite fin

		; ------------
		; Left Leg
		; ------------
		RD_LeftThigh=Proc_MakeRagdollJoint(MyMesh,"Bone23","RD_LeftThigh"+Seed$,"RD_Pelvis"+Seed$,3,TOK_HingeJoint%,90,0,0,-20,120); Cuisse gauche
		RD_LeftCaft=Proc_MakeRagdollJoint(MyMesh,"Bone24","RD_LeftCaft"+Seed$,"RD_LeftThigh"+Seed$,3,TOK_HingeJoint%,90,0,0,-70,0); Jambe gauche
		RD_LeftFoot=Proc_MakeRagdollJoint(MyMesh,"Bone25","RD_LeftFoot"+Seed$,"RD_LeftCaft"+Seed$,3,TOK_HingeJoint%,90,0,0,-20,40); Pied gauche
		RD_LeftFootEnd=Proc_MakeRagdollJoint(MyMesh,"Bone28","RD_LeftFootEnd"+Seed$,"RD_LeftFoot"+Seed$,2); Pied gauche fin

		; --------------
		; Right Leg
		; --------------
		RD_RightThigh=Proc_MakeRagdollJoint(MyMesh,"Bone18","RD_RightThigh"+Seed$,"RD_Pelvis"+Seed$,3,TOK_HingeJoint%,90,0,0,-20,120); Cuisse droite
		RD_RightCaft=Proc_MakeRagdollJoint(MyMesh,"Bone19","RD_RightCaft"+Seed$,"RD_RightThigh"+Seed$,3,TOK_HingeJoint%,90,0,0,-70,0); Jambe droite
		RD_RightFoot=Proc_MakeRagdollJoint(MyMesh,"Bone20","RD_RightFoot"+Seed$,"RD_RightCaft"+Seed$,3,TOK_HingeJoint%,90,0,0,-20,40); Pied droit
		RD_RightFootEnd=Proc_MakeRagdollJoint(MyMesh,"Bone26","RD_RightFootEnd"+Seed$,"RD_RightFoot"+Seed$,2); Pied droit fin

		; ----------------------------------------------------------------------------------
		; Mesh body (Pelvis, Spine 01, Spine 02, Head, Head End)
		; ----------------------------------------------------------------------------------
		EntityParent RD_Pelvis,TOK_GetRBMesh("RD_Pelvis"+Seed$)
		EntityParent RD_Spine01,TOK_GetRBMesh("RD_Spine01"+Seed$)
		EntityParent RD_Spine02,TOK_GetRBMesh("RD_Spine02"+Seed$)
		EntityParent RD_Head,TOK_GetRBMesh("RD_Head"+Seed$)
		EntityParent RD_HeadEnd,TOK_GetRBMesh("RD_HeadEnd"+Seed$)
		
		; -------------
		; Left Arm
		; -------------
		EntityParent RD_LeftClavicle,TOK_GetRBMesh("RD_LeftClavicle"+Seed$)
		EntityParent RD_LeftUpperArm,TOK_GetRBMesh("RD_LeftUpperArm"+Seed$)
		EntityParent RD_LeftForeArm,TOK_GetRBMesh("RD_LeftForeArm"+Seed$)
		EntityParent RD_LeftHand,TOK_GetRBMesh("RD_LeftHand"+Seed$)
		EntityParent RD_LeftHandEnd,TOK_GetRBMesh("RD_LeftHandEnd"+Seed$)
		
		; ---------------
		; Right Arm
		; ---------------
		EntityParent RD_RightClavicle,TOK_GetRBMesh("RD_RightClavicle"+Seed$)
		EntityParent RD_RightUpperArm,TOK_GetRBMesh("RD_RightUpperArm"+Seed$)
		EntityParent RD_RightForeArm,TOK_GetRBMesh("RD_RightForeArm"+Seed$)
		EntityParent RD_RightHand,TOK_GetRBMesh("RD_RightHand"+Seed$)
		EntityParent RD_RightHandEnd,TOK_GetRBMesh("RD_RightHandEnd"+Seed$)

		; -----------
		; Left Leg
		; -----------
		EntityParent RD_LeftThigh,TOK_GetRBMesh("RD_LeftThigh"+Seed$)
		EntityParent RD_LeftCaft,TOK_GetRBMesh("RD_LeftCaft"+Seed$)
		EntityParent RD_LeftFoot,TOK_GetRBMesh("RD_LeftFoot"+Seed$)
		EntityParent RD_LeftFootEnd,TOK_GetRBMesh("RD_LeftFootEnd"+Seed$)
		
		; --------------
		; Right Leg
		; --------------
		EntityParent RD_RightThigh,TOK_GetRBMesh("RD_RightThigh"+Seed$)
		EntityParent RD_RightCaft,TOK_GetRBMesh("RD_RightCaft"+Seed$)
		EntityParent RD_RightFoot,TOK_GetRBMesh("RD_RightFoot"+Seed$)
		EntityParent RD_RightFootEnd,TOK_GetRBMesh("RD_RightFootEnd"+Seed$)

		; -----------------------------------------------------------------------------------------------------------------------------------------------
		; Important : Parent the current mesh (pivot must be placed at the same place than the pelvis center)
		; -----------------------------------------------------------------------------------------------------------------------------------------------
		EntityParent MyMesh,TOK_GetRBMesh("RD_Pelvis"+Seed$)
End Function 

; --------------------------------------------------------------------------
; Function to make easily joint for ragdoll connection
; --------------------------------------------------------------------------
Function Proc_MakeRagdollJoint(ParentMesh,ParentBone$,PartName$,ConnectName$,BallScale#=3,JointType=TOK_HingeJoint%,JointPitch#=0,JointYaw#=0,JointRoll#=0,LAngle#=0,UAngle#=0)
	CubeAlpha#=0
	JointView=0

	RD_Tmp=Proc_GetChildMesh(ParentMesh,ParentBone$,"Pivot")
	TOK_CreateRBCube(PartName$,False,EntityX(RD_Tmp,True),EntityY(RD_Tmp,True),EntityZ(RD_Tmp,True),EntityPitch(RD_Tmp,True),EntityYaw(RD_Tmp,True),EntityRoll(RD_Tmp,True),BallScale#,BallScale#,BallScale#,3,"",255,255,255,1,0)
	TOK_EntityAlpha(PartName$,CubeAlpha#)
	
	RD_Joint=Proc_GetChildMesh(ParentMesh,ParentBone$,"Pivot")

	If LAngle#=0 And UAngle#=0 Then 
		LAngle#=-5
		UAngle#=5
	EndIf
	
	If JointPitch#=0 And JointYaw#=0 And JointRoll#=0 Then 
		JointPitch#=EntityPitch(RD_Joint,True)
		JointYaw#=EntityYaw(RD_Joint,True)
		JointRoll#=EntityRoll(RD_Joint,True)
	EndIf 

	TOK_CreateJoint(ParentBone$,2,PartName$,ConnectName$,EntityX(RD_Joint,True),EntityY(RD_Joint,True),EntityZ(RD_Joint,True),JointPitch#,JointYaw#,JointRoll#,JointView,JointType,100,LAngle#,UAngle#)

	Return RD_Tmp
End Function

; ---------------------------------------------------------------------------
; Function to get the bones under the animated mesh
; ---------------------------------------------------------------------------
Function Proc_GetChildMesh(Parent%,Name$,Class$)
	Children%=CountChildren(Parent%)

	For Loop = 1 To Children%
		Child=GetChild (Parent%,Loop)

		DebugLog "Function : Entity find : "+EntityName$(Child)+" / Class : "+EntityClass(Child)

		If Upper$(EntityName$(Child))=Upper$(Name$) And EntityClass(Child)=Class$ Then
			Return Child	
		Else
			Child_Tmp=Proc_GetChildMesh(Child,Name$,Class$)

			If Child_Tmp<>False Then
				Return Child_Tmp
			EndIf
		EndIf
	Next
End Function


